var action = "save";
var dq_bag_inspection_id = "";
var tableData = undefined;
$(document).ready(function () {
    tableData = $("#tblData").transactionTable({
        thead: [
            "Hour",
            "PRD",
            "UD",
            "SB",
            "BD",
            "PDHD",
            "RUD",
            "PD",
            "",
            "PRD",
            "UD",
            "SB",
            "BD",
            "PDHD",
            "RUD",
            "PD",
            "RE",
        ],
        column_def: { 0: 100 },
        auto_focus: 0,
        row_type: [
            { type: "select", value: "", align: "left", width: "60px" },
            { type: "text", value: "", align: "right" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left", disabled: "disabled" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "remark", value: "", align: "center" },
            { type: "remove", value: "X", align: "center" },
        ],
    });

    getOrderNo();
    getProductPrimaryId();
    getShiftData();
    getFactoryData();

    if (window.location.search.length > 0) {
        var sPageURL = window.location.search.substring(1);
        var param = sPageURL.split("?");
        dq_bag_inspection_id = param[0].split("=")[1].split("&")[0];
        action = param[0].split("=")[2].split("&")[0];
        getBiData(dq_bag_inspection_id);
        if (action == "edit") {
            $("#btnSave").text("Update");
        } else if (action == "view") {
            $("#btnSave").hide();
            $("#addRowBtn").hide();
            $("#reference_no").prop("disabled", true);
            $("#product_primary_id").prop("disabled", true);
            $("#customer_order_plan_data_id").prop("disabled", true);
            $("#date").prop("disabled", true);
            $("#factory").prop("disabled", true);
            $("#shift").prop("disabled", true);
            $("#size_of_product").prop("disabled", true);
        }
    } else {
        tableData.add_empty_row();
    }

    $("#btnSave").on("click", function () {
        if ($(this).text() == "Save") {
            saveBiRecord();
        } else {
            updateBiRecords(dq_bag_inspection_id);
        }
    });

    addRowData();
});

function addEmptyRow() {
    tableData.add_empty_row();
    addRowData();
}

function addRowData(hour) {
    var selected_row = tableData.getSelectedRow();
    var cells = selected_row.getElementsByTagName("td");

    $("#" + cells[0].childNodes[0].id).append('<option value="">--</option>');

    for (var i = 1; i < 25; i++) {
        if (hour == i) {
            $("#" + cells[0].childNodes[0].id).append(
                '<option value="' + i + '" selected>' + i + "</option>"
            );
        } else {
            $("#" + cells[0].childNodes[0].id).append(
                '<option value="' + i + '">' + i + "</option>"
            );
        }
    }
}

function getShiftData() {
    $.ajax({
        type: "GET",
        url: "/qc/DamageCheckingRecordsDataController/getShiftData",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#shift").append(
                    '<option value="' +
                        res[i].shift_id +
                        '">' +
                        res[i].shift_name +
                        "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}

function getFactoryData() {
    $.ajax({
        type: "GET",
        url: "/qc/SupervisorCheckListDataController/getFactoryData",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#factory").append(
                    '<option value="' +
                        res[i].site_id +
                        '">' +
                        res[i].site +
                        "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}

function getOrderNo() {
    $.ajax({
        type: "GET",
        url: "/qc/DamageCheckingRecordsHeaderController/getOrderNo",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#customer_order_plan_data_id").append(
                    '<option value="' +
                        res[i].customer_order_plan_data_id +
                        '">' +
                        res[i].order_id +
                        "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}

function getProductPrimaryId() {
    $.ajax({
        type: "GET",
        url: "/qc/DamageCheckingRecordsHeaderController/getProductPrimaryId",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            for (var i = 0; i < res.length; i++) {
                $("#product_primary_id").append(
                    '<option value="' +
                        res[i].product_primary_id +
                        '">' +
                        res[i].product_name +
                        "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}

function saveBiRecord() {
    var bi_data = {};
    var bi_data_arr = tableData.dataSource();
    if (bi_data_arr.length == 0) {
        showWarningMessage("Invalid data!");
        return;
    }
    for (var i = 0; i < bi_data_arr.length; i++) {
        if (!bi_data_arr[i][0]) {
            showWarningMessage("You shuld fill empty row in The list");
            return;
        }
        bi_data[i] = JSON.stringify({
            hour: bi_data_arr[i][0],
            print_damage: bi_data_arr[i][1],
            unseal_damage: bi_data_arr[i][2],
            seal_burning: bi_data_arr[i][3],
            bag_damage: bi_data_arr[i][4],
            plant_hole_damage: bi_data_arr[i][5],
            upside_down: bi_data_arr[i][6],
            production_damage: bi_data_arr[i][7],
            qc_print_damage: bi_data_arr[i][9],
            qc_unseal_damage: bi_data_arr[i][10],
            qc_seal_burning: bi_data_arr[i][11],
            qc_bag_damage: bi_data_arr[i][12],
            qc_plant_hole_damage: bi_data_arr[i][13],
            qc_upside_down: bi_data_arr[i][14],
            qc_production_damage: bi_data_arr[i][15],
            remarks: bi_data_arr[i][16],
        });
    }

    $.ajax({
        type: "POST",
        url: "/qc/DailyQualityBagInspectionDataController/save",
        data: {
            reference_no: $("#reference_no").val(),
            date: $("#date").val(),
            customer_order_plan_data_id: $(
                "#customer_order_plan_data_id"
            ).val(),
            product_primary_id: $("#product_primary_id").val(),
            factory: $("#factory").val(),
            shift: $("#shift").val(),
            size_of_product: $("#size_of_product").val(),
            bi_data: bi_data,
        },
        headers: {
            "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
        },
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                toastr.success("data saved");
                $("#tblData")
                    .find("input[type=text], select")
                    .each(function () {
                        $(this).val("");
                    });

                $("#product_primary_id").val("");
                $("#customer_order_plan_data_id").val("");
                $("#date").val("");
                $("#factory").val("");
                $("#shift").val("");
                $("#size_of_product").val("");
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error("Something went wrong");
        },
        complete: function () {},
    });
}

function getBiData(id) {
    $.ajax({
        type: "GET",
        url: "/qc/DailyQualityBagInspectionDataController/getBiData/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            // progress(true);
        },
        success: function (response) {
            var res = response.data.result;
            $("#reference_no").val(res.reference_no);
            $("#date").val(res.date);
            $("#customer_order_plan_data_id").val(
                res.customer_order_plan_data_id
            );
            $("#product_primary_id").val(res.product_primary_id);
            $("#factory").val(res.factory);
            $("#shift").val(res.shift);
            $("#size_of_product").val(res.size_of_product);

            var request_data = res.request_data;
            for (var i = 0; i < request_data.length; i++) {
                tableData.addRow([
                    {
                        type: "select",
                        val: request_data[i].hour,
                        align: "left",
                        width: "60px",
                    },
                    {
                        type: "text",
                        val: request_data[i].print_damage,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].unseal_damage,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].seal_burning,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].bag_damage,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].plant_hole_damage,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].upside_down,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].production_damage,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: "",
                        align: "left",
                        disabled: "disabled",
                    },
                    {
                        type: "text",
                        val: request_data[i].qc_print_damage,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].qc_unseal_damage,
                        align: "right",
                    },
                    {
                        type: "text",
                        val: request_data[i].qc_seal_burning,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].qc_bag_damage,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].qc_plant_hole_damage,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].qc_upside_down,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].qc_production_damage,
                        align: "left",
                    },
                    {
                        type: "remark",
                        val: request_data[i].remarks,
                        align: "center",
                    },
                    {
                        type: "remove",
                        val: "X",
                        align: "center",
                    },
                ]);

                addRowData(request_data[i].hour);
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {
            // progress(false);
        },
    });
}

function updateBiRecords(dq_bag_inspection_id) {
    var bi_data = {};
    var bi_data_arr = tableData.dataSource();
    if (bi_data_arr.length == 0) {
        showWarningMessage("Invalied Data");
        return;
    }
    for (var i = 0; i < bi_data_arr.length; i++) {
        if (!bi_data_arr[i][0]) {
            showWarningMessage("You shuld fill empty row in The list");
            return;
        }
        bi_data[i] = JSON.stringify({
            hour: bi_data_arr[i][0],
            print_damage: bi_data_arr[i][1],
            unseal_damage: bi_data_arr[i][2],
            seal_burning: bi_data_arr[i][3],
            bag_damage: bi_data_arr[i][4],
            plant_hole_damage: bi_data_arr[i][5],
            upside_down: bi_data_arr[i][6],
            production_damage: bi_data_arr[i][7],
            qc_print_damage: bi_data_arr[i][9],
            qc_unseal_damage: bi_data_arr[i][10],
            qc_seal_burning: bi_data_arr[i][11],
            qc_bag_damage: bi_data_arr[i][12],
            qc_plant_hole_damage: bi_data_arr[i][13],
            qc_upside_down: bi_data_arr[i][14],
            qc_production_damage: bi_data_arr[i][15],
            remarks: bi_data_arr[i][16],
        });
    }

    $.ajax({
        type: "PUT",
        url: "/qc/DailyQualityBagInspectionDataController/update/" + dq_bag_inspection_id,
        data: {
            reference_no: $("#reference_no").val(),
            date: $("#date").val(),
            customer_order_plan_data_id: $(
                "#customer_order_plan_data_id"
            ).val(),
            product_primary_id: $("#product_primary_id").val(),
            factory: $("#factory").val(),
            shift: $("#shift").val(),
            size_of_product: $("#size_of_product").val(),
            bi_data: bi_data,
        },
        headers: {
            "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
        },
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                toastr.success("data updated");
                location.href = "/qc/dqBagInspectionList";
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error("Something went wrong");
        },
        complete: function () {},
    });
}

function triggerRowInputs(id, selected_row) {

}



function transactionTableUpdate(table_id) {
    // override function from transaction_table.js
}


/**
 * showSuccessMessage
 * This function is used to show success message.
 * @param message This is the paramter to require message content
 */
function showSuccessMessage(message) {
    toastr.success(message);
}

/**
 * showWarningMessage
 * This function is used to show warning message.
 * @param message This is the paramter to require message content
 */
function showWarningMessage(message) {
    toastr.warning(message);
}

/**
 * showErrorMessage
 * This function is used to show error message.
 * @param message This is the paramter to require message content
 */
function showErrorMessage() {
    toastr.error("Something went wrong");
}
