var action = "save";
var pwr_id = "";
var tableData = undefined;
$(document).ready(function () {
    tableData = $("#tblData").transactionTable({
        thead: ["Hour", "Sample No", "OB 1", "OB 2", "OB 3", "OB 4", "OB 5", "Average"],
        column_def: { 0: 100 },
        auto_focus: 0,
        row_type: [
            { type: "select", value: "", align: "left", width: "60px" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left", disabled: "disabled" },
            { type: "remove", value: "X", align: "right" },
        ],
    });

    getOrderNo();
    getProductPrimaryId();
    getFactoryData();

    if (window.location.search.length > 0) {
        var sPageURL = window.location.search.substring(1);
        var param = sPageURL.split("?");
        pwr_id = param[0].split("=")[1].split("&")[0];
        action = param[0].split("=")[2].split("&")[0];
        getPwrData(pwr_id);
        if (action == "edit") {
            $("#btnSave").text("Update");
        } else if (action == "view") {
            $("#btnSave").hide();
            $("#addRowBtn").hide();
            $("#reference_no").prop("disabled", true);
            $("#product_primary_id").prop("disabled", true);
            $("#customer_order_plan_data_id").prop("disabled", true);
            $("#date").prop("disabled", true);
            $("#factory").prop("disabled", true);
        }
    } else {
        tableData.add_empty_row();
    }

    $("#btnSave").on("click", function () {
        if ($(this).text() == "Save") {
            savePwrRecord();
        } else {
            updatePwrRecords(pwr_id);
        }
    });

    addRowData();
});

function addEmptyRow() {
    tableData.add_empty_row();
    addRowData();
}

function addRowData(hour) {
    var selected_row = tableData.getSelectedRow();
    var cells = selected_row.getElementsByTagName("td");

    $("#" + cells[0].childNodes[0].id).append('<option value="">--</option>');

    for (var i = 1; i < 25; i++) {
        if (hour == i) {
            $("#" + cells[0].childNodes[0].id).append(
                '<option value="' + i + '" selected>' + i + "</option>"
            );
        } else {
            $("#" + cells[0].childNodes[0].id).append(
                '<option value="' + i + '">' + i + "</option>"
            );
        }
    }
}

function getFactoryData() {
    $.ajax({
        type: "GET",
        url: "/qc/SupervisorCheckListDataController/getFactoryData",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#factory").append(
                    '<option value="' +
                        res[i].site_id +
                        '">' +
                        res[i].site +
                        "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}

function getOrderNo() {
    $.ajax({
        type: "GET",
        url: "/qc/DamageCheckingRecordsHeaderController/getOrderNo",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#customer_order_plan_data_id").append(
                    '<option value="' +
                        res[i].customer_order_plan_data_id +
                        '">' +
                        res[i].order_id +
                        "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}

function getProductPrimaryId() {
    $.ajax({
        type: "GET",
        url: "/qc/DamageCheckingRecordsHeaderController/getProductPrimaryId",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            for (var i = 0; i < res.length; i++) {
                $("#product_primary_id").append(
                    '<option value="' +
                        res[i].product_primary_id +
                        '">' +
                        res[i].product_name +
                        "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}

function savePwrRecord() {
    var pwr_data = {};
    var pwr_data_arr = tableData.dataSource();
    if (pwr_data_arr.length == 0) {
        showWarningMessage("Invalid data!");
        return;
    }
    for (var i = 0; i < pwr_data_arr.length; i++) {
        if (!pwr_data_arr[i][0]) {
            showWarningMessage("You shuld fill empty row in The list");
            return;
        }
        pwr_data[i] = JSON.stringify({
            hour: pwr_data_arr[i][0],
            sample_no: pwr_data_arr[i][1],
            ob1: pwr_data_arr[i][2],
            ob2: pwr_data_arr[i][3],
            ob3: pwr_data_arr[i][4],
            ob4: pwr_data_arr[i][5],
            ob5: pwr_data_arr[i][6],
        });
    }

    $.ajax({
        type: "POST",
        url: "/qc/ProductionWeightReportController/save",
        data: {
            reference_no: $("#reference_no").val(),
            date: $("#date").val(),
            customer_order_plan_data_id: $(
                "#customer_order_plan_data_id"
            ).val(),
            product_primary_id: $("#product_primary_id").val(),
            factory: $("#factory").val(),
            pwr_data: pwr_data,
        },
        headers: {
            "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
        },
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                toastr.success("data saved");
                $("#tblData")
                    .find("input[type=text], select")
                    .each(function () {
                        $(this).val("");
                    });

                $("#reference_no").val("");
                $("#product_primary_id").val("");
                $("#customer_order_plan_data_id").val("");
                $("#date").val("");
                $("#factory").val("");
                getOrderNo();
                getProductPrimaryId();
                getFactoryData();
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error("Something went wrong");
        },
        complete: function () {},
    });
}

function getPwrData(id) {
    $.ajax({
        type: "GET",
        url: "/qc/ProductionWeightReportController/getPwrData/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            // progress(true);
        },
        success: function (response) {
            var res = response.data.result;
            $("#reference_no").val(res.reference_no);
            $("#date").val(res.date);
            $("#customer_order_plan_data_id").val(
                res.customer_order_plan_data_id
            );
            $("#product_primary_id").val(res.product_primary_id);
            $("#factory").val(res.factory);

            var request_data = res.request_data;
            for (var i = 0; i < request_data.length; i++) {
                tableData.addRow([
                    {
                        type: "select",
                        val: request_data[i].hour,
                        align: "left",
                        width: "60px",
                    },
                    {
                        type: "text",
                        val: request_data[i].sample_no,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].ob1,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].ob2,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].ob3,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].ob4,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].ob5,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].average,
                        align: "left",
                        disabled: "disabled",
                    },
                    {
                        type: "remove",
                        val: "X",
                        align: "center",
                    },
                ]);

                addRowData(request_data[i].hour);
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {
            // progress(false);
        },
    });
}

function updatePwrRecords(pwr_id) {
    var pwr_data = {};
    var pwr_data_arr = tableData.dataSource();
    if (pwr_data_arr.length == 0) {
        showWarningMessage("Invalied Data");
        return;
    }
    for (var i = 0; i < pwr_data_arr.length; i++) {
        if (!pwr_data_arr[i][0]) {
            showWarningMessage("You shuld fill empty row in The list");
            return;
        }
        pwr_data[i] = JSON.stringify({
            hour: pwr_data_arr[i][0],
            sample_no: pwr_data_arr[i][1],
            ob1: pwr_data_arr[i][2],
            ob2: pwr_data_arr[i][3],
            ob3: pwr_data_arr[i][4],
            ob4: pwr_data_arr[i][5],
            ob5: pwr_data_arr[i][6],
        });
    }

    $.ajax({
        type: "PUT",
        url:
            "/qc/ProductionWeightReportController/update/" +
            pwr_id,
        data: {
            reference_no: $("#reference_no").val(),
            date: $("#date").val(),
            customer_order_plan_data_id: $(
                "#customer_order_plan_data_id"
            ).val(),
            product_primary_id: $("#product_primary_id").val(),
            factory: $("#factory").val(),
            pwr_data: pwr_data,
        },
        headers: {
            "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
        },
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                toastr.success("data updated");
                location.href = "/qc/pwReportsList";
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error("Something went wrong");
        },
        complete: function () {},
    });
}

function triggerRowInputs(id, selected_row) {
    if (id == "tblData") {
        var cells = selected_row.getElementsByTagName("td");
        var ob1 = $("#" + cells[2].childNodes[0].id);
        var ob2 = $("#" + cells[3].childNodes[0].id);
        var ob3 = $("#" + cells[4].childNodes[0].id);
        var ob4 = $("#" + cells[5].childNodes[0].id);
        var ob5 = $("#" + cells[6].childNodes[0].id);

        var input_arr = [ob1, ob2, ob3, ob4, ob5];

        input_arr.forEach((input) => {
            input.on("input", function () {
                var val_ob1 = parseFloat(ob1.val()) || 0;
                var val_ob2 = parseFloat(ob2.val()) || 0;
                var val_ob3 = parseFloat(ob3.val()) || 0;
                var val_ob4 = parseFloat(ob4.val()) || 0;
                var val_ob5 = parseFloat(ob5.val()) || 0;

                var total = (val_ob1 + val_ob2 + val_ob3 + val_ob4 + val_ob5)/5;
                $("#" + cells[7].childNodes[0].id).val(total);
            });
        });
    }
}

function transactionTableUpdate(table_id) {
    // override function from transaction_table.js
}

/**
 * showSuccessMessage
 * This function is used to show success message.
 * @param message This is the paramter to require message content
 */
function showSuccessMessage(message) {
    toastr.success(message);
}

/**
 * showWarningMessage
 * This function is used to show warning message.
 * @param message This is the paramter to require message content
 */
function showWarningMessage(message) {
    toastr.warning(message);
}

/**
 * showErrorMessage
 * This function is used to show error message.
 * @param message This is the paramter to require message content
 */
function showErrorMessage() {
    toastr.error("Something went wrong");
}
